#!lua5.1

local filename = ...
local varname = filename
local pos, new_pos = 1, 0
repeat
  pos = new_pos + 1
  new_pos = varname:find('/', pos, true)
until new_pos == nil
varname = varname:sub(pos, -5)
varname = varname:gsub("[^%w_]",'_'):upper()

local file, error = io.open(filename,'r')
if error then
  print(error)
  return -1
end
local out
out = '#define '..varname.." {\\\n"
local all = file:read('*a')
local len = #all
for i=1, len, 16 do
  out = out .. "\t".. (table.concat({all:byte(i, math.min(i+15, len))}, ', ')) .. ", \\\n"
end
out = out .. "\t}"
out = out .. "\n#define ".. varname.. "_SIZE ".. len .."\n"

file:close()
file = io.open(filename:sub(1,-5)..'.h','w')
file:write(out)
file:close()
