create schema plluac;

set search_path = plluac;

CREATE OR REPLACE FUNCTION pllua_validator(oid)
  RETURNS void AS
'$libdir/plluac', 'pllua_validator'
  LANGUAGE 'c' VOLATILE;
ALTER FUNCTION pllua_validator(oid) OWNER TO postgres;

CREATE OR REPLACE FUNCTION pllua_call_handler()
  RETURNS language_handler AS
'$libdir/plluac', 'pllua_call_handler'
  LANGUAGE 'c' VOLATILE;
ALTER FUNCTION pllua_call_handler() OWNER TO postgres;

CREATE PROCEDURAL LANGUAGE 'plluacu'
  HANDLER plluac.pllua_call_handler
  VALIDATOR plluac.pllua_validator;

CREATE OR REPLACE FUNCTION pllua_call_handler_simple()
  RETURNS language_handler AS
'$libdir/plluac', 'pllua_call_handler_simple'
  LANGUAGE 'c' VOLATILE;
ALTER FUNCTION pllua_call_handler() OWNER TO postgres;

CREATE PROCEDURAL LANGUAGE 'plluacu_simple'
  HANDLER plluac.pllua_call_handler_simple
  VALIDATOR plluac.pllua_validator;
/*
CREATE TRUSTED PROCEDURAL LANGUAGE 'plluac'
  HANDLER plluac.pllua_call_handler
  VALIDATOR plluac.pllua_validator;
*/

create table plluac.initial_scripts (
  id serial primary key,
  name varchar not null,
  body text not null
);
create index plluac_scripts_functions_ix_name on plluac.initial_scripts ( name );