set names 'sql_ascii';
set lc_messages='C';

create or replace function test_pg_table_row_finder(id int4)
returns test_lua
language plluacu
as $$
  local findq = pg_table.test_lua:row_finder({'id'})
  return findq(id)
$$;

create or replace function test_pg_table_row_finder_name(id int4)
returns varchar
language plluacu
as $$
  local findq = pg_table.test_lua:row_finder({'id'},{'name'})
  local res = findq(id)
  return res and res.name
$$;

create or replace function test_pg_table_updater(id int4, name varchar)
returns void
language plluacu
as $$
  pg_table.test_lua:row_updater({'id'}, {'name'})(id, name)
$$;

create or replace function test_pg_table_inserter()
returns test_lua
language plluacu
as $$
  local new_row = pg_table.test_lua:row_inserter({'name', 'names', 'sums'}, {'id'})(
                                    'hello', {'hello1', 'hello2'}, { {ids={1,2},sums={3,4}} }
                                    )
  local res = nil
  if new_row then
    res = pg_table.test_lua:row_finder({'id'})(new_row.id)
    pg_table.test_lua:row_deleter({'id'})(new_row.id)
  end
  return res
$$;

select test_pg_table_row_finder_name(1);
select * from test_pg_table_row_finder(1);
select test_pg_table_updater(1, 'hi1_1');
select * from test_pg_table_row_finder(1);
select test_pg_table_updater(1, 'hi1');
select * from test_pg_table_inserter();

