set names 'sql_ascii';
set lc_messages='C';

create or replace function test_recordset_lua1()
returns setof id_sum
language plluacu
as $$
  local i = 1
  coroutine.yield({ids = {i+1, i+2}, sums={i+ 0.4, i+0.6} })
  i = i + 1
  spi.return_next({ids = {i+1, i+2}, sums={i+ 0.4, i+0.6} })
  i = i + 1
  return ipairs{
    {ids = {i+1, i+2}, sums={i+ 0.4, i+0.6} },
    {ids = {i+6, i+6}, sums={i+ 0.5, i+0.7} }
    }
$$; 

select t.ids, t.sums from test_recordset_lua1() as t;

create or replace function test_recordset_lua2()
returns setof id_sum
language plluacu
as $$--[==[prepare
  local insert = table.insert
  local function add_arr(ar, i)
      insert(ar, {ids = {i+1, i+2}, sums={i+ 0.4, i+0.6} })
  end
--]==]
  local i = 1
  local ar = {}
  add_arr(ar, i)
  i = i + 1
  add_arr(ar, i)
  spi.return_next( ipairs(ar) )
  spi.return_next( set(ar) )
  ar = {}
  i = i + 1
  add_arr(ar, i)
  i = i + 1
  add_arr(ar, i)
  return set(ar)
$$; 

select t.ids, t.sums from test_recordset_lua2() as t;