set names 'sql_ascii';
set lc_messages='C';

drop table if exists test2;
create table test2 (
  id serial primary key,
  name text
);

insert into test2 (name) values ('HELLO :-)');

create or replace function pllua_transaction(not_modify boolean)
returns void
language plluacu
as $$
  local outset_count = 0
  local function outset(set)
    outset_count = outset_count + 1
    for i, row in ipairs(spi.execute 'select * from test2') do
      spi.info(outset_count .. ":  id = ".. row.id .. " name = " .. spi.quote(row.name))
    end
  end
  local function transaction(...)
    local good, val = spi.transaction(...)
    if good then
      spi.notice('OK SO FAR')
    else
      spi.notice('ROLLBACKED ' .. val)
    end
  end
  outset(spi.execute('select * from test2'))
  transaction(function()
    transaction(function()
      spi.execute [[insert into test2(name) values(E'\\hi')]]
      outset(spi.execute('select * from test2'))
      spi.execute [[insert into test2(name) values(E'\\ho')]]
    end)
    outset(spi.execute('select * from test2'))
    transaction(function()
      spi.execute [[insert into test2(name) values(E'\\hi')]]
      outset(spi.execute('select * from test2'))
      spi.execute [[insert into test2(id, name) values(1, E'\\ho')]]
    end)
    outset(spi.execute('select * from test2'))
    if not_modify then
      error("F_CK THE WORLD :-)")
    end
  end)
  outset(spi.execute('select * from test2'))
$$;
select pllua_transaction(false);
select pllua_transaction(true);
select pllua_transaction(true);