set names 'sql_ascii';
set lc_messages='C';

CREATE OR REPLACE FUNCTION test_lua1(i integer)
  RETURNS two_arrays AS
$BODY$
  return raw('({1},{'..(i+1)..'})')
$BODY$
  LANGUAGE 'plluacu' VOLATILE;

select test_lua1(1);

CREATE OR REPLACE FUNCTION test_lua2(i integer)
  RETURNS setof two_arrays AS
$BODY$
  for j=1,10 do
--    spi.return_next( raw('({1},{'..(i+j)..'})') )
    coroutine.yield( raw('({1},{'..(i+j)..'})') )
  end
$BODY$
  LANGUAGE 'plluacu' VOLATILE;

select * from test_lua2(1);

create or replace function test_lua3(i integer)
returns timestamp
language plluacu
as $$
  return raw('2008-01-02 03:04:0'..i)
$$;

select test_lua3(2);

create or replace function test_lua4(i integer, cnt integer)
returns setof timestamp
language plluacu
as $$
 for j=1, cnt do
  spi.return_next( raw('2008-01-02 03:04:0'..((i+j)%10)) )
 end
$$;

select * from test_lua4(2, 10);

create or replace function test_lua5(i integer)
returns timestamp
language plluacu
as $$
  local f = spi.parse('2008-01-02 03:04:0'..i, 'timestamp')
  spi.info(f)
  return f
$$;

select test_lua5(2);

create or replace function test_lua6(i integer)
returns float[]
language plluacu
as $$
  local f = ('{'..i..','..(i+1)..'}'):spi_parse( 'float[]')
  spi.info(tostring(f))
  return f
$$;

select test_lua6(2);

create or replace function test_lua7(i integer)
returns float[]
language plluacu
as $$
  local f = ('{'..i..','..(i+1)..'}'):spi_parse(1022)
  spi.info(tostring(f))
  return f
$$;

select test_lua7(3);

create or replace function test_lua8(i integer)
returns two_arrays
 AS
$BODY$
  local f = spi.parse('({1},{'..(i+1)..'})', 'two_arrays')
  spi.info(tostring(f))
  return f
$BODY$
LANGUAGE 'plluacu' VOLATILE;

select test_lua8(2);

CREATE OR REPLACE FUNCTION test_lua9(i integer, cnt integer)
  RETURNS setof two_arrays AS
$BODY$
  for j=1,cnt do
    spi.return_next( raw('({1},{'..(i+j)..'})') )
  end
$BODY$
  LANGUAGE 'plluacu' VOLATILE;

select max(r.two) from test_lua9(1, 5) as r;


CREATE OR REPLACE FUNCTION test_lua10(i integer, cnt integer)
  RETURNS setof two_arrays AS
$BODY$
  local two_arrays = pg_type.two_arrays
  for j=1,cnt do
    spi.return_next( spi.parse('({1},{'..(i+j)..'})', two_arrays) )
  end
$BODY$
  LANGUAGE 'plluacu' VOLATILE;

select max(r.two) from test_lua10(1, 5) as r;

CREATE OR REPLACE FUNCTION test_lua11(i integer, cnt integer)
  RETURNS setof two_arrays AS
$BODY$
  for j=1,cnt do
    spi.return_next( spi.parse('({1},{'..(i+j)..'})', 'two_arrays') )
  end
$BODY$
  LANGUAGE 'plluacu' VOLATILE;

select max(r.two) from test_lua11(1, 5) as r;

