set names 'sql_ascii';
set lc_messages='C';

create or replace function test_typename_pllua()
returns void
language plluacu
as $$--[==[prepare
  local info = spi.info
--]==]
  for _,v in ipairs({
      'numeric(8)',
      'numeric(8,3)',
      'numeric(8,4)',
      'numeric(8,5)',
      'numeric(0)',
      'decimal(8)',
      'decimal(8,3)',
      'decimal(8,4)',
      'decimal(8,5)',
      'numeric','timestamptz','timestamptz(3)',
      'interval'}) do
    local good, tp= spi.transaction(function() return pg_type[v] end)
    if not good then
      local err = tp
      info(err)
    else
      local s = v
      s = s .. ' = { '..tp[1]..', '..tp[2]..'}'
      s = s .. ' = ' .. pg_type.get_name(tp)
      s = s .. ' = ' .. pg_type.get_name(tp, true)
      info(s)
    end
  end
$$;

create or replace function pllua_command_id()
returns void
language plluacu
as $$
  spi.info(spi.command_id())
  spi.execute('select 1')
  spi.info(spi.command_id())
  spi.execute('select * from test2')
  spi.info(spi.command_id())
  spi.execute [[insert into test2(name) values(E'\\hi')]]
  spi.info(spi.command_id())
--  local good, err = pcall(spi.execute, "insert into test2(id) values('hi')")
  local good, err = spi.transaction(spi.execute, "insert into test2(id) values('hi')")
  spi.info(err)
  for i, row in ipairs(spi.execute 'select * from test2') do
    spi.info("id = ".. row.id .. " name = " .. spi.quote(row.name) .. " '" .. row.name .. "'")
  end
  spi.info(spi.command_id())
  spi.execute "delete from test2 where id > 1"
  spi.info(spi.command_id())
  spi.info(spi.to_quoted(100000000, 'timestamp'))
  spi.info(spi.to_quoted({ '\\hi', 'ho' }, 'text[]'))
  spi.info(spi.to_repr({ '\\hi', 'ho' }, 'text[]'))
$$ volatile;

select pllua_command_id();

begin;
select test_typename_pllua();
select pllua_command_id();
commit;
